// StandAloneBatchSpecificationSet.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;


/**
 * The container generated by an order and containing the spefications about
 * a stand alone batch process
 *
 * @author Pietro Terna
 */
public class StandAloneBatchSpecificationSet  extends SwarmObjectImpl{

    /** number (i.e. that of the order which has generated this object */
    public int myOrderNumber;
    /** the position of this sequence in the recipe */
    public int pos;
    /** the specifications */
    public int productionTimeInTicks;

  /**
   * constructor for StandAloneBatchSpecificationSet
   */
  public StandAloneBatchSpecificationSet (Zone aZone, int n, int p) {

     // Call the constructor for the parent class
     super(aZone);

     myOrderNumber=n;
     pos=p;

	if(StartESFrame.verbose)
	    System.out.println("Stand alone b. spec. created " +
			       "(by order " + myOrderNumber + " at pos. " + 
			       pos + "; NB first pos. is 0)");
  }

    /** setting the stand alone batch specifications */
    public void setSpecifications(int k)
    {
	productionTimeInTicks = k;

	if(StartESFrame.verbose)
	System.out.println("Stand alone batch production time in ticks " +
			 productionTimeInTicks);
    }

    /** decrease production time */
    public int decreaseProductionTime(){

	if(StartESFrame.verbose)
	    System.out.println(
             "Residual production time in stand alone production set from"+
	     " order " + myOrderNumber+" at pos " + pos +": " + 
	     productionTimeInTicks);
	productionTimeInTicks--;
	return productionTimeInTicks;
    }


    /**
     * returning the number of the order of this procurement specification
     */
    public int getNumber () {
	return myOrderNumber;
   }

    /**
     * returning the position of this procurement specification into its recipe
     */
    public int getPositionInRecipe() {
	return pos;
   }

}
